POJ 3126 Prime Path (BFS)

Prime Path
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 14799 Accepted: 8345

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题目链接:http://poj.org/problem?id=3126

题目大意:给定两个四位数的质数a,b,由a开始,每次变换一位上的数字得到一个新的四位质数,直到变换得到b,求最少变换的次数。如果没有解,输出“Impossible”。

解题思路:典型BFS暴力,预处理一下素数筛就行,改变位上的数字时用数组存储该四位数。

代码如下:

#include <cstdio>
#include <cstring>
#include <queue>
using namespace std;
int n,m,prm[100000],vis[100000];
struct node
{
    int x,cnt;
};
void get_prime()    //得到四位数的素数晒
{
    memset(prm,0,sizeof(prm));
    for(int i=1000;i<=9999;i++)
    {
        bool p=true;
        for(int j=2;j*j<=i;j++)
        {
            if(i%j==0)
            {
                p=false;
                break;
            }
        }
        if(p)
            prm[i]=1;
    }
}
int bfs()
{
    queue<node>q;
    node sd;
    sd.x=n,sd.cnt=0;
    q.push(sd);
    while(!q.empty())
    {
        node nn,nd=q.front();
        q.pop();
        if(nd.x==m)
            return nd.cnt;
        int a[4];
        int tm=nd.x;
        for(int i=0;i<4;i++)
        {
            a[i]=tm%10;
            tm/=10;
        }      
        for(int i=0;i<4;i++)         //枚举每一位上的数字
        {           
            for(int j=0;j<=9;j++)        //枚举当前位上要改变的数字
            {
                if(j==a[i] || i==3&&j==0)continue;
                int cur;
                if(i==0)
                    cur=a[3]*1000+a[2]*100+a[1]*10+j;
                else if(i==1)
                    cur=a[3]*1000+a[2]*100+j*10+a[0];
                else if(i==2)
                    cur=a[3]*1000+j*100+a[1]*10+a[0];
                else
                    cur=j*1000+a[2]*100+a[1]*10+a[0];
                if(vis[cur] || !prm[cur])continue;   //如果下一个数字被访问过或者不是质数,跳过
                vis[cur]=1;
                nn.x=cur;
                nn.cnt=nd.cnt+1;
                q.push(nn);
            }
        }     
    }
    return -1;
}
int main(void)
{
    int t;
    get_prime();
    scanf("%d",&t);
    while(t--)
    {
        memset(vis,0,sizeof(vis));
        scanf("%d%d",&n,&m);
        vis[n]=1;
        int ans=bfs();
        if(ans==-1)
            printf("Impossible\n");
        else
            printf("%d\n",ans);
    }
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值